/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_SM4DECISION_H
#define DPC_IMPL_TYPE_SM4DECISION_H

#include <cfloat>
#include <cmath>
#include "impl_type_uint8.h"
#include "impl_type_uint32.h"
#include "impl_type_float.h"

namespace dpc {
struct SM4Decision {
    ::UInt8 sm_lfcmfrtavlbhvr{ 0U };
    ::UInt32 sm_lfcmfrtavlbhvr_crdrid{ 0U };
    ::UInt8 sm_lcavlbhvr{ 0U };
    ::UInt32 sm_lcavlbhvr_crdrid{ 0U };
    ::UInt8 sm_lcpavlbhvr{ 0U };
    ::UInt8 sm_lcpavlbhvr_crdrid{ 0U };
    ::UInt8 sm_lssavlbhvr{ 0U };
    ::UInt8 sm_lgtavlbhvr{ 0U };
    ::UInt8 sm_sftystp{ 0U };
    ::UInt8 sm_latactvfunc{ 0U };
    ::UInt8 sm_drvmd{ 0U };
    ::UInt8 sm_nrp_lcavl{ 0U };
    ::UInt8 sm_drvr_indctdrct{ 0U };
    ::Float sm_drvrsetspd{ 0.0F };
    ::UInt8 sm_seltdistlvl{ 0U };
    ::UInt8 sm_fdout_strgy_lat{ 0U };
    ::UInt8 sm_fdin_strgy_lat{ 0U };
    ::UInt8 sm_fdout_strgy_lgt{ 0U };
    ::UInt8 sm_fdin_strgy_lgt{ 0U };
    ::UInt8 sm_spdlmtid01{ 0U };
    ::UInt8 sm_speedlimit01{ 0U };
    ::Float sm_controlwaypoint_offset01{ 0.0F };
    ::UInt8 sm_spdlmtid02{ 0U };
    ::UInt8 sm_speedlimit02{ 0U };
    ::Float sm_controlwaypoint_offset02{ 0.0F };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(sm_lfcmfrtavlbhvr);
        fun(sm_lfcmfrtavlbhvr_crdrid);
        fun(sm_lcavlbhvr);
        fun(sm_lcavlbhvr_crdrid);
        fun(sm_lcpavlbhvr);
        fun(sm_lcpavlbhvr_crdrid);
        fun(sm_lssavlbhvr);
        fun(sm_lgtavlbhvr);
        fun(sm_sftystp);
        fun(sm_latactvfunc);
        fun(sm_drvmd);
        fun(sm_nrp_lcavl);
        fun(sm_drvr_indctdrct);
        fun(sm_drvrsetspd);
        fun(sm_seltdistlvl);
        fun(sm_fdout_strgy_lat);
        fun(sm_fdin_strgy_lat);
        fun(sm_fdout_strgy_lgt);
        fun(sm_fdin_strgy_lgt);
        fun(sm_spdlmtid01);
        fun(sm_speedlimit01);
        fun(sm_controlwaypoint_offset01);
        fun(sm_spdlmtid02);
        fun(sm_speedlimit02);
        fun(sm_controlwaypoint_offset02);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(sm_lfcmfrtavlbhvr);
        fun(sm_lfcmfrtavlbhvr_crdrid);
        fun(sm_lcavlbhvr);
        fun(sm_lcavlbhvr_crdrid);
        fun(sm_lcpavlbhvr);
        fun(sm_lcpavlbhvr_crdrid);
        fun(sm_lssavlbhvr);
        fun(sm_lgtavlbhvr);
        fun(sm_sftystp);
        fun(sm_latactvfunc);
        fun(sm_drvmd);
        fun(sm_nrp_lcavl);
        fun(sm_drvr_indctdrct);
        fun(sm_drvrsetspd);
        fun(sm_seltdistlvl);
        fun(sm_fdout_strgy_lat);
        fun(sm_fdin_strgy_lat);
        fun(sm_fdout_strgy_lgt);
        fun(sm_fdin_strgy_lgt);
        fun(sm_spdlmtid01);
        fun(sm_speedlimit01);
        fun(sm_controlwaypoint_offset01);
        fun(sm_spdlmtid02);
        fun(sm_speedlimit02);
        fun(sm_controlwaypoint_offset02);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("sm_lfcmfrtavlbhvr", sm_lfcmfrtavlbhvr);
        fun("sm_lfcmfrtavlbhvr_crdrid", sm_lfcmfrtavlbhvr_crdrid);
        fun("sm_lcavlbhvr", sm_lcavlbhvr);
        fun("sm_lcavlbhvr_crdrid", sm_lcavlbhvr_crdrid);
        fun("sm_lcpavlbhvr", sm_lcpavlbhvr);
        fun("sm_lcpavlbhvr_crdrid", sm_lcpavlbhvr_crdrid);
        fun("sm_lssavlbhvr", sm_lssavlbhvr);
        fun("sm_lgtavlbhvr", sm_lgtavlbhvr);
        fun("sm_sftystp", sm_sftystp);
        fun("sm_latactvfunc", sm_latactvfunc);
        fun("sm_drvmd", sm_drvmd);
        fun("sm_nrp_lcavl", sm_nrp_lcavl);
        fun("sm_drvr_indctdrct", sm_drvr_indctdrct);
        fun("sm_drvrsetspd", sm_drvrsetspd);
        fun("sm_seltdistlvl", sm_seltdistlvl);
        fun("sm_fdout_strgy_lat", sm_fdout_strgy_lat);
        fun("sm_fdin_strgy_lat", sm_fdin_strgy_lat);
        fun("sm_fdout_strgy_lgt", sm_fdout_strgy_lgt);
        fun("sm_fdin_strgy_lgt", sm_fdin_strgy_lgt);
        fun("sm_spdlmtid01", sm_spdlmtid01);
        fun("sm_speedlimit01", sm_speedlimit01);
        fun("sm_controlwaypoint_offset01", sm_controlwaypoint_offset01);
        fun("sm_spdlmtid02", sm_spdlmtid02);
        fun("sm_speedlimit02", sm_speedlimit02);
        fun("sm_controlwaypoint_offset02", sm_controlwaypoint_offset02);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("sm_lfcmfrtavlbhvr", sm_lfcmfrtavlbhvr);
        fun("sm_lfcmfrtavlbhvr_crdrid", sm_lfcmfrtavlbhvr_crdrid);
        fun("sm_lcavlbhvr", sm_lcavlbhvr);
        fun("sm_lcavlbhvr_crdrid", sm_lcavlbhvr_crdrid);
        fun("sm_lcpavlbhvr", sm_lcpavlbhvr);
        fun("sm_lcpavlbhvr_crdrid", sm_lcpavlbhvr_crdrid);
        fun("sm_lssavlbhvr", sm_lssavlbhvr);
        fun("sm_lgtavlbhvr", sm_lgtavlbhvr);
        fun("sm_sftystp", sm_sftystp);
        fun("sm_latactvfunc", sm_latactvfunc);
        fun("sm_drvmd", sm_drvmd);
        fun("sm_nrp_lcavl", sm_nrp_lcavl);
        fun("sm_drvr_indctdrct", sm_drvr_indctdrct);
        fun("sm_drvrsetspd", sm_drvrsetspd);
        fun("sm_seltdistlvl", sm_seltdistlvl);
        fun("sm_fdout_strgy_lat", sm_fdout_strgy_lat);
        fun("sm_fdin_strgy_lat", sm_fdin_strgy_lat);
        fun("sm_fdout_strgy_lgt", sm_fdout_strgy_lgt);
        fun("sm_fdin_strgy_lgt", sm_fdin_strgy_lgt);
        fun("sm_spdlmtid01", sm_spdlmtid01);
        fun("sm_speedlimit01", sm_speedlimit01);
        fun("sm_controlwaypoint_offset01", sm_controlwaypoint_offset01);
        fun("sm_spdlmtid02", sm_spdlmtid02);
        fun("sm_speedlimit02", sm_speedlimit02);
        fun("sm_controlwaypoint_offset02", sm_controlwaypoint_offset02);
    }

    friend bool operator==(const ::dpc::SM4Decision& lhs, const ::dpc::SM4Decision& rhs) noexcept
    {
        return (lhs.sm_lfcmfrtavlbhvr == rhs.sm_lfcmfrtavlbhvr) && (lhs.sm_lfcmfrtavlbhvr_crdrid == rhs.sm_lfcmfrtavlbhvr_crdrid) && (lhs.sm_lcavlbhvr == rhs.sm_lcavlbhvr) && (lhs.sm_lcavlbhvr_crdrid == rhs.sm_lcavlbhvr_crdrid) && (lhs.sm_lcpavlbhvr == rhs.sm_lcpavlbhvr) && (lhs.sm_lcpavlbhvr_crdrid == rhs.sm_lcpavlbhvr_crdrid) && (lhs.sm_lssavlbhvr == rhs.sm_lssavlbhvr) && (lhs.sm_lgtavlbhvr == rhs.sm_lgtavlbhvr) && (lhs.sm_sftystp == rhs.sm_sftystp) && (lhs.sm_latactvfunc == rhs.sm_latactvfunc) && (lhs.sm_drvmd == rhs.sm_drvmd) && (lhs.sm_nrp_lcavl == rhs.sm_nrp_lcavl) && (lhs.sm_drvr_indctdrct == rhs.sm_drvr_indctdrct) && (fabs(static_cast<double>(lhs.sm_drvrsetspd - rhs.sm_drvrsetspd)) < DBL_EPSILON) && (lhs.sm_seltdistlvl == rhs.sm_seltdistlvl) && (lhs.sm_fdout_strgy_lat == rhs.sm_fdout_strgy_lat) && (lhs.sm_fdin_strgy_lat == rhs.sm_fdin_strgy_lat) && (lhs.sm_fdout_strgy_lgt == rhs.sm_fdout_strgy_lgt) && (lhs.sm_fdin_strgy_lgt == rhs.sm_fdin_strgy_lgt) && (lhs.sm_spdlmtid01 == rhs.sm_spdlmtid01) && (lhs.sm_speedlimit01 == rhs.sm_speedlimit01) && (fabs(static_cast<double>(lhs.sm_controlwaypoint_offset01 - rhs.sm_controlwaypoint_offset01)) < DBL_EPSILON) && (lhs.sm_spdlmtid02 == rhs.sm_spdlmtid02) && (lhs.sm_speedlimit02 == rhs.sm_speedlimit02) && (fabs(static_cast<double>(lhs.sm_controlwaypoint_offset02 - rhs.sm_controlwaypoint_offset02)) < DBL_EPSILON);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_SM4DECISION_H
